/*
 * $Header: /auto/nfs/sequoia/u/home/rws/pextk/include/PEXtk.h,v 1.1 1993/10/12 00:08:17 rws Exp $
 ******************************************************************************
 ******************************************************************************
 *****                             PEXtk.h                                *****
 *****									  *****
 *****									  *****
 *                                                                            *
 *	Copyright 1992, All Rights Reserved                                   *
 *			SHOgraphics					      *
 *			1890 North Shoreline Blvd			      *
 *			Mountain View, CA    94043			      *
 *                                                                            *
 *****									  *****

    Permission to use, copy, modify, and distribute this software and
 its documentation for any purpose and without fee is hereby granted,
 provided that the above copyright notice appear in all copies and that
 both that copyright notice and this permission notice appear in
 supporting documentation, and that the name of SHOgraphics not be
 used in advertising or publicity pertaining to distribution of the 
 software without specific, written prior permission.

 SHOGRAPHICS DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 INCLUDING ALL EXPRESSED AND IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS. IN NO EVENT SHALL SHOGRAPHICS BE LIABLE FOR ANY DAMAGES OF ANY
 KIND, INCLUDING BUT NOT LIMITED LIMITED TO SPECIAL, INDIRECT OR 
 CONSEQUENTIAL DAMAGES RESULTING FROM LOSS OF USE, DATA OR PROSPECTIVE
 PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS 
 ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
 SOFTWARE.

 ************************************************************************ */

#ifndef PEXTK_H
#define PEXTK_H

#ifndef FALSE
#define FALSE	0
#endif

#ifndef TRUE
#define TRUE	1
#endif

/* defines for single/double buffer mode */

#define		PEXtk_SINGLE_BUFFER	0
#define		PEXtk_DOUBLE_BUFFER	1

/* defines for projection matrix type */

#define         PEXtk_VIEW_PERSP	0
#define         PEXtk_VIEW_ORTHO	1
#define         PEXtk_VIEW_ORTHO_2D	2
#define         PEXtk_VIEW_LOOKAT	3
#define         PEXtk_VIEW_POLAR	4
#define         PEXtk_VIEW_WINDOW	5

/* defines for zbuffer */

#define		PEXtk_ZBUFFER_OFF	0
#define		PEXtk_ZBUFFER_ON	1
#define		PEXtk_ZBUFFER_RESET	2
#define		PEXtk_ANTIALIAS		3

/* defines for backface culling */

#define		PEXtk_CULL_NONE		0
#define		PEXtk_CULL_BACKFACE	1
#define		PEXtk_CULL_FRONTFACE	2

/* defines for fill style */

#define		PEXtk_FILL_HOLLOW	1
#define		PEXtk_FILL_SOLID	2

/* defines for matrix mode */

#define		PEXtk_MATRIX_MODELING	0
#define		PEXtk_MATRIX_VIEWING	1
#define		PEXtk_MATRIX_PROJ	2

/* defines for bitmask attributes */

#define		GACOLOR			0x01
#define		GANORMAL		0x02

/* defines for clearing */

#define		PEXtk_CLEAR_VPT		0x01
#define		PEXtk_CLEAR_Z		0x02

/* defines for color types */

#define		PEXtk_COLOR_RGB		0
#define		PEXtk_COLOR_INDEXED	1
#define		PEXtk_COLOR_HSV		2
#define		PEXtk_COLOR_HLS		3
#define		PEXtk_COLOR_CIE		4

/* defines for shade mode */

#define		PEXtk_SHADE_NONE	0x000
#define		PEXtk_SHADE_WIRE	0x001
#define		PEXtk_SHADE_FLAT	0x002
#define		PEXtk_SHADE_COLORS	0x008
#define		PEXtk_SHADE_NORMALS	0x010
#define		PEXtk_SHADE_SPECULAR	0x020
#define		PEXtk_SHADE_LIGHTS	0x040
#define		PEXtk_SHADE_HIDDENLINE	0x080
#define		PEXtk_SHADE_ANTIALIAS	0x100
#define		PEXtk_SHADE_DOTPRODUCT	0x200

/* defines for reflection properties */

#define		PEXtk_REFL_AMBIENT	1
#define		PEXtk_REFL_DIFFUSE	2
#define		PEXtk_REFL_SPECULAR	3
#define		PEXtk_REFL_EXPONENT	4

#define		PEXtk_MTL_KA   		1
#define		PEXtk_MTL_KD   		2
#define		PEXtk_MTL_KS   		3

#define		PEXtk_LIGHT_OFF		0
#define		PEXtk_LIGHT_AMBIENT	1
#define		PEXtk_LIGHT_INFINITE	2
#define		PEXtk_LIGHT_POINT	3
#define		PEXtk_LIGHT_SPOT	4
#define		PEXtk_LIGHT_AREA	5

#define		PEXtk_Off		0x00
#define		PEXtk_On		0x01
#define		PEXtk_Set		0x02

#define		PEXtk_MAX_BUFFERS	16
#define		PEXtk_MAX_LIGHTS	32
#define		PEXtk_MTX_SIZE		32
#define		PEXtk_VIEW_SIZE		32
#define		PEXtk_VPT_SIZE		32
#define		PEXtk_ATTRIB_SIZE	32

/* defines for Markers */

#define 	PEXtk_MRKR_POINT	1
#define 	PEXtk_MRKR_CIRCLE	2
#define 	PEXtk_MRKR_CROSS	3
#define 	PEXtk_MRKR_X		4
#define 	PEXtk_MRKR_ASTERISK	5
#define 	PEXtk_MRKR_BOX		6

/* defines for Line Types */

#define 	PEXtk_LINE_SOLID	1
#define 	PEXtk_LINE_DASHED	2
#define 	PEXtk_LINE_DOTTED	3
#define 	PEXtk_LINE_DASHDOT	4

/* defines for Polygon Border Types */

#define 	PEXtk_BORDER_NONE	0
#define 	PEXtk_BORDER_SOLID	1
#define 	PEXtk_BORDER_DASHED	2
#define 	PEXtk_BORDER_DOTTED	3
#define 	PEXtk_BORDER_DASHDOT	4

/* defines for shape flag */

#define		PEXtk_SHAPE_COMPLEX	0
#define		PEXtk_SHAPE_NONCONVEX	1
#define		PEXtk_SHAPE_CONVEX	2
#define		PEXtk_SHAPE_UNKNOWN	3

/* defines for Text */

#define		PEXtk_TEXT_PATH_RIGHT	0
#define		PEXtk_TEXT_PATH_LEFT	1
#define		PEXtk_TEXT_PATH_UP	2
#define		PEXtk_TEXT_PATH_DOWN	3

#define		PEXtk_TEXT_VALIGN_NORM 	 0
#define		PEXtk_TEXT_VALIGN_TOP 	 1
#define		PEXtk_TEXT_VALIGN_CAP	 2
#define		PEXtk_TEXT_VALIGN_HALF	 3
#define		PEXtk_TEXT_VALIGN_BASE	 4
#define		PEXtk_TEXT_VALIGN_BOTTOM 5

#define		PEXtk_TEXT_HALIGN_NORM 	 0
#define		PEXtk_TEXT_HALIGN_LEFT	 1
#define		PEXtk_TEXT_HALIGN_CTR 	 2
#define		PEXtk_TEXT_HALIGN_RIGHT  3

/* defines for Rational or NonRational curves or surfaces */

#define		PEXtk_RATIONAL		0
#define		PEXtk_NONRATIONAL	1

/* defines for approximation methods for curves or surfaces */

#define		PEXtk_APPROX_IMP_DEP		1
#define		PEXtk_APPROX_CONSTANT_KNOTS	2
#define		PEXtk_APPROX_WC_CHORD_LEN	3
#define		PEXtk_APPROX_NC_CHORD_LEN	4
#define		PEXtk_APPROX_DC_CHORD_LEN	5
#define		PEXtk_APPROX_WC_CHORD_DEV	6
#define		PEXtk_APPROX_NC_CHORD_DEV	7
#define		PEXtk_APPROX_DC_CHORD_DEV	8
#define		PEXtk_APPROX_WC_RELATIVE	9
#define		PEXtk_APPROX_NC_RELATIVE	10
#define		PEXtk_APPROX_DC_RELATIVE	11

/* defines for buffer update action */

#define		PEXtk_BUFFER_UNDEFINED		0
#define		PEXtk_BUFFER_BACKGROUND		1
#define		PEXtk_BUFFER_UNTOUCHED		2
#define		PEXtk_BUFFER_COPIED		3

/* defines for setting function pointers */

#define		PEXtk_INFO_MAX_LIGHTS	0x0001
#define		PEXtk_INFO_ZBUFFER	0x0002
#define		PEXtk_INFO_ANTIALIAS	0x0004
#define		PEXtk_INFO_DITHER	0x0008
#define		PEXtk_INFO_TRANSPARENCY	0x0010
#define		PEXtk_INFO_LIGHT_TYPES	0x0020
#define		PEXtk_INFO_LINE_TYPES	0x0040
#define		PEXtk_INFO_BORDER_TYPES	0x0080
#define		PEXtk_INFO_MAX_NAMES   	0x0100
#define		PEXtk_INFO_SHADE_MODES 	0x0200
#define		PEXtk_INFO_MAX_VIEWS	0x0400

/* defines for setting function pointers */

#define		PEXtk_FUNC_CLEAR_BUFFER		1
#define		PEXtk_FUNC_CREATE_BUFFER	2
#define		PEXtk_FUNC_DELETE_BUFFER	3
#define		PEXtk_FUNC_SWAP_BUFFER		4
#define		PEXtk_FUNC_CLEAR_ZBUFFER	5
#define		PEXtk_FUNC_PIXEL_INDEX		6
#define		PEXtk_FUNC_PIXEL_RGB		7
#define		PEXtk_FUNC_DITHER		8
#define		PEXtk_FUNC_TRANSPARENCY		9
#define		PEXtk_FUNC_ANTIALIAS		10

/* defines for errors */

#define		PEXtk_ERR_CLASS_MASK	0xff00
#define		PEXtk_ERR_CODE_MASK	0x00ff

#define		PEXtk_ERR_CLASS_DLS	0x0100
#define		PEXtk_ERR_CLASS_STR	0x0200
#define		PEXtk_IS_OPEN		0x0001
#define		PEXtk_NOT_OPEN		0x0002

#define		PEXtk_ERR_DLS_OPEN	(PEXtk_ERR_CLASS_DLS | PEXtk_IS_OPEN)
#define		PEXtk_ERR_DLS_CLOSED	(PEXtk_ERR_CLASS_DLS | PEXtk_NOT_OPEN)
#define		PEXtk_ERR_STR_OPEN	(PEXtk_ERR_CLASS_STR | PEXtk_IS_OPEN)
#define		PEXtk_ERR_STR_CLOSED	(PEXtk_ERR_CLASS_STR | PEXtk_NOT_OPEN)

/* typedefs for variable types */

typedef float		Fcoord;
typedef float		Fdata;
typedef float		Angle;
typedef int		Screencoord;
typedef float		Matrix[4][4];

typedef float  		Fcoord3[3];
#ifndef U_LONG
typedef unsigned long 	U_LONG;
#endif

typedef struct  colorIndex {
	int	value;
	} colorIndex;

typedef struct	rgbFloat {
	float	red;
	float	green;
	float	blue;
	} rgbFloat;

typedef struct	hsvFloat {
	float	hue;
	float	saturation;
	float	value;
	} hsvFloat;

typedef struct	hlsFloat {
	float	hue;
	float	lightness;
	float	saturation;
	} hlsFloat;

typedef struct	cieFloat {
	float	u;
	float	v;
	float	Y;
	} cieFloat;

typedef struct PCOLOR {
	int		type;
	union {
	    colorIndex	index;
	    rgbFloat	rgb;
	    hsvFloat	hsv;
	    hlsFloat	hls;
	    cieFloat	cie;
	    } color;
	} PCOLOR;

typedef struct {
	Fcoord	x;
	Fcoord	y;
	} Fcoord2D;

typedef struct {
	Fcoord	x;
	Fcoord	y;
	Fcoord	z;
	} Fcoord3D;

typedef struct {
	Fcoord	x;
	Fcoord	y;
	Fcoord	z;
	Fcoord	w;
	} Fcoord4D;

typedef struct {
	int		id;
	int		flag;
	int		type;
	Fcoord3D	dir;
	Fcoord3D	pos;
	float		angle;
	float		conc;
	float		atten1;
	float		atten2;
	} PEXtk_LIGHT;

typedef struct Tvar {
	float	u,v;
	} Tvar;

typedef	struct {
	int	left;				/* viewport x_ll */
	int	right;				/* viewport x_ur */
	int	bottom;				/* viewport y_ll */
	int	top;				/* viewport y_ur */
	} PEXtk_VIEWPORT;

typedef struct {
	int	visibility;
	int	order;
	int	type;				/* Rational or NonRational */
	float   tmin;				/* parameter range */
	float   tmax;				/* parameter range */
	int	numPoints;			/* number of control points */
	float   *knots;				/* Knot vector */
	float	*points;			/* control points */
	} PEXtkTrimCurve;			/* same as pexTrimCurveData */

typedef struct {
	int		numTrimCurves;
	PEXtkTrimCurve	*trimCurves;
	} PEXtkTrimLoop;			/* same as pexTrimLoop */


typedef Fcoord3D	PEXtkCoord3D;

/* connectivity list for Ppoly_index */
typedef struct {
    unsigned short      count;                  /* number of shorts */
    unsigned short      *shorts;
} PListOfUShort;

typedef struct {
    unsigned short      count;                  /* number of lists */
    PListOfUShort       *lists;
} PConnectivityData;

#if defined(__cplusplus) || defined (c_plusplus)
extern "C" {
#endif /* __cplusplus */
extern	int	Pinit( 
#if PEXtk_PROTOTYPES
	Display*	/* dpy */
#endif
);
extern	void	Pexit(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Parc(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x   */,
	Fcoord 		/* y   */,
	Fcoord 		/* z   */,
	Fcoord 		/* rad */,
	Angle 		/* beg  */,
	Angle 		/* end */
#endif
);
extern	void	Parc_fill(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x   */,
	Fcoord 		/* y   */,
	Fcoord 		/* z   */,
	Fcoord 		/* rad */,
	Angle 		/* beg  */,
	Angle 		/* end */
#endif
);
extern	void	Pbackface(
#if PEXtk_PROTOTYPES
	int 		/* mode */
#endif
);
extern	void	Pbegin_line(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Pbegin_poly(
#if PEXtk_PROTOTYPES
	int		/* style */
#endif
);
extern	void	Pbegin_tmesh(
#if PEXtk_PROTOTYPES
	int		/* style */
#endif
);
extern	void	Pborder(
#if PEXtk_PROTOTYPES
	int 		/* type */
#endif
);
extern	void	Pbuffer_mode(
#if PEXtk_PROTOTYPES
	int 		/* mode */
#endif
);
extern	void	Pcall_display_list(
#if PEXtk_PROTOTYPES
	int 		/* name */
#endif
);
extern	void	Pcall_struct(
#if PEXtk_PROTOTYPES
	int 		/* name */
#endif
);
extern	void	Pcircle(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x   */,
	Fcoord 		/* y   */,
	Fcoord 		/* z   */,
	Fcoord 		/* rad */
#endif
);
extern	void	Pcircle_fill(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x   */,
	Fcoord 		/* y   */,
	Fcoord 		/* z   */,
	Fcoord 		/* rad */
#endif
);
extern	void	Pclear(
#if PEXtk_PROTOTYPES
	PCOLOR*		/* col */
#endif
);
extern	void	Pclear_hsv(
#if PEXtk_PROTOTYPES
	Fdata 		/* h */,
	Fdata 		/* s */,
	Fdata 		/* v */
#endif
);
extern	void	Pclear_ind(
#if PEXtk_PROTOTYPES
	int 		/* index */
#endif
);
extern	void	Pclear_rgb(
#if PEXtk_PROTOTYPES
	Fdata 		/* r */,
	Fdata 		/* g */,
	Fdata 		/* b */
#endif
);
extern	void	Pclip_rectangle(
#if PEXtk_PROTOTYPES
	Screencoord 	/* left   */, 
	Screencoord 	/* right  */,
	Screencoord 	/* bottom */,
	Screencoord 	/* top    */
#endif
);
extern	void	Pclose_display_list(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Pclose_struct(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Pcolor(
#if PEXtk_PROTOTYPES
	PCOLOR*		/* col */
#endif
);
extern	void	Pcolor_hsv(
#if PEXtk_PROTOTYPES
	Fdata 		/* h */,
	Fdata 		/* s */,
	Fdata 		/* v */
#endif
);
extern	void	Pcolor_ind(
#if PEXtk_PROTOTYPES
	int 		/* index */
#endif
);
extern	void	Pcolor_rgb(
#if PEXtk_PROTOTYPES
	Fdata 		/* r */,
	Fdata 		/* g */,
	Fdata 		/* b */
#endif
);
extern	int	Pcreate_display_list(
#if PEXtk_PROTOTYPES
	int 		/* name */
#endif
);
extern	int	Pcreate_struct(
#if PEXtk_PROTOTYPES
	int 		/* name */
#endif
);
extern	void	Pcurve_approx_method(
#if PEXtk_PROTOTYPES
	int 		/* meth */,
	Fdata 		/* tol */
#endif
);
extern	void	Pcurve_parm_range(
#if PEXtk_PROTOTYPES
	Fdata 		/* umin */,
	Fdata 		/* umax */
#endif

);
extern	int	Pdelete_display_list(
#if PEXtk_PROTOTYPES
	int 		/* name */
#endif
);

extern	int	Pdelete_struct(
#if PEXtk_PROTOTYPES
	int 		/* name */
#endif
);

extern	void	Pdepth(
#if PEXtk_PROTOTYPES
	Fcoord  	/* near */,
	Fcoord 		/* far */
#endif
);
extern	void	Pdepth_cue(
#if PEXtk_PROTOTYPES
	int 		/* type */,
	Fcoord  	/* near */,
	Fcoord 		/* far */
#endif
);
extern	void	Pdither(
#if PEXtk_PROTOTYPES
	int 		/* flag */,
	int 		/* pattern */
#endif
);
extern	int	Pdisplay_list_used(
#if PEXtk_PROTOTYPES
	int 		/* name */
#endif
);

extern	void	Pdraw_2d(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x */,
	Fcoord 		/* y */
#endif
);
extern	void	Pdraw_3d(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x */,
	Fcoord 		/* y */,
	Fcoord 		/* z */ 
#endif
);
extern	int	Pedit_multiply_matrix(
#if PEXtk_PROTOTYPES
	int 		/* name */,
	int 		/* label */,
	Matrix  	/* mat */,
	int 		/* flag */
#endif
);
extern	int	Pedit_struct(
#if PEXtk_PROTOTYPES
	int 		/* name */
#endif
);
extern	int	Pend_line(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	int	Pend_poly(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	int	Pend_tmesh(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Pexec_struct(
#if PEXtk_PROTOTYPES
	int 		/* name */
#endif
);
extern	void	Pflush(
#if PEXtk_PROTOTYPES
	int 		/* flag */
#endif
);
extern	unsigned long Pget_backbuffer(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	int	Pget_backface(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	int	Pget_border(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	int	Pget_buffer_mode(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Pget_clip_rectangle(
#if PEXtk_PROTOTYPES
	Screencoord*	/* left   */,
	Screencoord*	/* right  */,
	Screencoord*	/* bottom */,
	Screencoord*	/* top    */
#endif
);
extern	void	Pget_color(
#if PEXtk_PROTOTYPES
	PCOLOR*		/* col */
#endif
);
extern	int	Pget_depth_cue(
#if PEXtk_PROTOTYPES
	Fcoord*		/* rmin */,
	Fcoord*		/* rmax */
#endif
);
extern	unsigned long Pget_frontbuffer(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Pget_identity_matrix( 
#if PEXtk_PROTOTYPES
	Matrix  	/* mat */
#endif
);
extern	void	Pget_inverse_matrix(
#if PEXtk_PROTOTYPES
	Matrix  	/* mat */
#endif
);
extern	void	Pget_line_color(
#if PEXtk_PROTOTYPES
	PCOLOR*		/* col */
#endif
);
extern	int	Pget_line_type(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	Fdata	Pget_line_width(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Pget_marker_color(
#if PEXtk_PROTOTYPES
	PCOLOR*		/* col */
#endif
);
extern	int	Pget_marker_type(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Pget_matrix(
#if PEXtk_PROTOTYPES
	Matrix  	/* mat */
#endif
);
extern	int	Pget_shade_mode(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Pget_specular_color(
#if PEXtk_PROTOTYPES
	PCOLOR*		/* col */
#endif
);
extern	int	Pget_structmatrix(
#if PEXtk_PROTOTYPES
	int		/* name  */,
	int		/* label */,
	Matrix  	/* mat   */
#endif
);
extern	int	Pget_structure(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	int	Pget_support_info(
#if PEXtk_PROTOTYPES
	int		/* type */,
	int**		/* data */
#endif
);
extern	void	Pget_text_color(
#if PEXtk_PROTOTYPES
	PCOLOR*		/* col */
#endif
);
extern	int	Pget_view(
#if PEXtk_PROTOTYPES
	Fcoord*		/* left   */,
	Fcoord*		/* right  */,
	Fcoord*		/* bottom */,
	Fcoord*		/* top    */,
	Fcoord*		/* fov    */,
	Fcoord*		/* aspect */,
	Fcoord*		/* far    */,
	Fcoord*		/* near   */
#endif
);
extern	int	Pget_viewport(
#if PEXtk_PROTOTYPES
	Screencoord*	/* left   */,
	Screencoord*	/* right  */,
	Screencoord*	/* bottom */,
	Screencoord*	/* top    */
#endif
);
extern	int	Pget_zbuffer(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	int	Pinsert_struct(
#if PEXtk_PROTOTYPES
	int 		/* label */
#endif
);
extern	int	Plabel_used(
#if PEXtk_PROTOTYPES
	int 		/* name  */,
	int 		/* label */
#endif
);
extern	void	Plight(
#if PEXtk_PROTOTYPES
	int 		/* id  */,
	PEXtk_LIGHT*	/* lgt */
#endif
);
extern	void	Plight_ambient(
#if PEXtk_PROTOTYPES
	Fdata 		/* amb */
#endif
);
extern	void	Plight_color(
#if PEXtk_PROTOTYPES
	PCOLOR*		/* col */
#endif
);
extern	void	Plight_color_hsv(
#if PEXtk_PROTOTYPES
	Fdata 		/* h */,
	Fdata 		/* s */,
	Fdata 		/* v */
#endif
);
extern	void	Plight_color_ind(
#if PEXtk_PROTOTYPES
	int		/* index */
#endif
);
extern	void	Plight_color_rgb(
#if PEXtk_PROTOTYPES
	Fdata 		/* r */,
	Fdata 		/* g */,
	Fdata 		/* b */
#endif
);
extern	void	Pline_color(
#if PEXtk_PROTOTYPES
	PCOLOR*		/* col */
#endif
);
extern	void	Pline_color_hsv(
#if PEXtk_PROTOTYPES
	Fdata 		/* h */,
	Fdata 		/* s */,
	Fdata 		/* v */
#endif
);
extern	void	Pline_color_ind(
#if PEXtk_PROTOTYPES
	int		/* index */
#endif
);
extern	void	Pline_color_rgb(
#if PEXtk_PROTOTYPES
	Fdata 		/* r */,
	Fdata 		/* g */,
	Fdata 		/* b */
#endif
);
extern	void	Pline_type(
#if PEXtk_PROTOTYPES
	int		/* type */
#endif
);
extern	void	Pline_width(
#if PEXtk_PROTOTYPES
	Fdata		/* width */
#endif
);
extern	char **Plist_fonts(
#if PEXtk_PROTOTYPES
	int 		/* max       */
	char* 		/* pattern   */
	int* 		/* num_found */
#endif
);
extern	void	Pload_attribute(
#if PEXtk_PROTOTYPES
	int  		/* attrib */,
	void*  		/* valueptr */
#endif
);
extern	void	Pload_identity(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Pload_matrix(
#if PEXtk_PROTOTYPES
	Matrix  	/* mat */
#endif
);
extern	void	Plogical_function(
#if PEXtk_PROTOTYPES
	unsigned long  	/* func */
#endif
);
extern	void	Plookat_view(
#if PEXtk_PROTOTYPES
	Fcoord 		/* vx */,
	Fcoord 		/* vy */,
	Fcoord 		/* vz */,
	Fcoord 		/* px */,
	Fcoord 		/* py */,
	Fcoord 		/* pz */,
	Angle 		/* twist */
#endif
);
extern	int	Pmake_label(
#if PEXtk_PROTOTYPES
	int 		/* label */
#endif
);
extern	void	Pmarker(
#if PEXtk_PROTOTYPES
	int 		/* n   */,
	Fcoord3D*	/* pts */
#endif
);
extern	void	Pmarker_color(
#if PEXtk_PROTOTYPES
	PCOLOR*		/* col */
#endif
);
extern	void	Pmarker_color_hsv(
#if PEXtk_PROTOTYPES
	Fdata 		/* h */,
	Fdata 		/* s */,
	Fdata 		/* v */
#endif
);
extern	void	Pmarker_color_ind(
#if PEXtk_PROTOTYPES
	int		/* index */
#endif
);
extern	void	Pmarker_color_rgb(
#if PEXtk_PROTOTYPES
	Fdata 		/* r */,
	Fdata 		/* g */,
	Fdata 		/* b */
#endif
);
extern	void	Pmarker_scale(
#if PEXtk_PROTOTYPES
	Fdata 		/* scale */
#endif
);
extern	void	Pmarker_type(
#if PEXtk_PROTOTYPES
	int 		/* type */ 
#endif
);
extern	void	Pmatrix_mode(
#if PEXtk_PROTOTYPES
	int 		/* type */ 
#endif
);
extern	void	Pmove_2d(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x */,
	Fcoord 		/* y */
#endif
);
extern	void	Pmove_3d(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x */,
	Fcoord 		/* y */,
	Fcoord 		/* z */ 
#endif
);
extern	void	Pmultiply_matrix(
#if PEXtk_PROTOTYPES
	Matrix 		/* mat  */,
	int 		/* flag */
#endif
);
extern	void	Pnurb_curve(
#if PEXtk_PROTOTYPES
	int 		/* type  */,
	int 		/* order */,
	int 		/* nKnot */,
	float* 		/* knots */,
	int 		/* nPts  */,
	Fcoord*		/* pts   */
#endif
);
extern	void	Pnurb_surface(
#if PEXtk_PROTOTYPES
	int 		/* type   */,
	int 		/* uorder */,
	int 		/* vorder */,
	int 		/* nUKnot */,
	float* 		/* uknots */,
	int 		/* nVKnot */,
	float* 		/* vknots */,
	int 		/* uPts  */,
	int 		/* vPts  */,
	Fcoord*		/* pts   */,
	PEXtkTrimLoop*	/* trim  */,
	int		/* nloop */
#endif
);

extern	void	Portho_2d_view(
#if PEXtk_PROTOTYPES
	int 		/* index */, 
	Fcoord 		/* left   */, 
	Fcoord 		/* right  */,
	Fcoord 		/* bottom */,
	Fcoord 		/* top    */
#endif
);
extern	void	Portho_view(
#if PEXtk_PROTOTYPES
	int 		/* index */, 
	Fcoord 		/* left */,
	Fcoord 		/* right */, 
	Fcoord 		/* bottom */,
	Fcoord 		/* top */,
	Fcoord  	/* near */,
	Fcoord 		/* far */
#endif
);
extern	void	Ppersp_view(
#if PEXtk_PROTOTYPES
	int 		/* index */,
	Fcoord 		/* fov */,
	Fcoord 		/* aspect */, 
	Fcoord  	/* near */,
	Fcoord 		/* far */
#endif
);

extern	void	Ppick_id(
#if PEXtk_PROTOTYPES
	int 		/* id */
#endif
);
extern	void	Pplane_mask(
#if PEXtk_PROTOTYPES
	unsigned long	/* mask */
#endif
);
extern	void	Ppoint_2d(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x */,
	Fcoord 		/* y */
#endif
);
extern	void	Ppoint_3d(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x */,
	Fcoord 		/* y */,
	Fcoord 		/* z */
#endif
);
extern	void	Ppolar_view(
#if PEXtk_PROTOTYPES
	Fcoord 		/* dist  */,
	Angle 		/* azim  */,
	Angle 		/* inc   */, 
	Angle 		/* twist */
#endif
);

extern	void	Ppoly(
#if PEXtk_PROTOTYPES
	int 		/* n */,
	Fcoord3D*	/* pts */
#endif
);
extern	int	Ppoly_close(
#if PEXtk_PROTOTYPES
	void 		
#endif
);
extern	void	Ppoly_fill(
#if PEXtk_PROTOTYPES
	int 		/* n */,
	Fcoord3D*	/* pts */
#endif
);
extern	void	Ppoly_fill_area(
#if PEXtk_PROTOTYPES
	long 		/* polyMask */,
	long 		/* vertMask */,
	int 		/* nvert    */,
	int 		/* ctype    */,
	Fcoord*		/* polyData */,
	Fcoord*		/* vertData */
#endif
);
extern	void	Ppoly_index(
#if PEXtk_PROTOTYPES
	long 		/* polyMask */,
	long 		/* vertMask */,
	int 		/* npoly    */,
	int 		/* nvert    */,
	int 		/* numEdges */,
	int 		/* ctype    */,
	short* 		/* plyCount */,
	Fcoord*		/* polyData */,
	short* 		/* edges    */,
	Fcoord*		/* vertData */
#endif
);
extern	void	Ppoly_line(
#if PEXtk_PROTOTYPES
	int 		/* n */,
	Fcoord3D*	/* pts */
#endif
);
extern	void	Ppoly_normal(
#if PEXtk_PROTOTYPES
	Fcoord		/* x  */,
	Fcoord		/* y  */,
	Fcoord		/* z  */
#endif
);
extern	void	Ppoly_point_2d(
#if PEXtk_PROTOTYPES
	Fcoord		/* x  */,
	Fcoord		/* y  */
#endif
);
extern	void	Ppoly_point_3d(
#if PEXtk_PROTOTYPES
	Fcoord		/* x  */,
	Fcoord		/* y  */,
	Fcoord		/* z  */
#endif
);
extern	void	Ppoly_point_nv(
#if PEXtk_PROTOTYPES
	Fcoord		/* x  */,
	Fcoord		/* y  */,
	Fcoord		/* z  */,
	Fcoord		/* nx */,
	Fcoord		/* ny */,
	Fcoord		/* nz */
#endif
);
extern	void	Ppoly_point_nv_uv(
#if PEXtk_PROTOTYPES
	Fcoord		/* x  */,
	Fcoord		/* y  */,
	Fcoord		/* z  */,
	Fcoord		/* nx */,
	Fcoord		/* ny */,
	Fcoord		/* nz */,
	Fcoord		/* ux */,
	Fcoord		/* uy */
#endif
);
extern	void	Ppoly_point_uv(
#if PEXtk_PROTOTYPES
	Fcoord		/* x  */,
	Fcoord		/* y  */,
	Fcoord		/* z  */,
	Fcoord		/* ux */,
	Fcoord		/* uy */
#endif
);
extern	void	Ppoly_shade(
#if PEXtk_PROTOTYPES
	int 		/* n      */,
	Fcoord3D*	/* points */,
	Fcoord3D*	/* vnorms */
#endif
);
extern	void	Ppoly_shade_texture(
#if PEXtk_PROTOTYPES
	int 		/* n      */,
	Fcoord3D*	/* pts    */,
	Fcoord3D*	/* vnorms */,
	Tvar*		/* txvert */
#endif
);
extern	void	Ppoly_texture( 
#if PEXtk_PROTOTYPES
	int 		/* n   */,
	Fcoord3D*	/* pts */,
	Tvar*		/* tex */
#endif
);
extern	void	Ppoly_with_data( 
#if PEXtk_PROTOTYPES
	int 		/* type   */,
	int 		/* nPts   */,
	Fcoord3D*	/* points */,
	int 		/* ndata  */,
	void*		/* pdata  */
#endif
);

extern	void	Ppop_attributes(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Ppop_matrix(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Ppop_name(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Ppop_view(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Ppop_viewport(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Ppush_attributes(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Ppush_matrix(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Ppush_name(
#if PEXtk_PROTOTYPES
	int 		/* name */
#endif
);
extern	void	Ppush_view(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Ppush_viewport(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Prectangle(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x_ll */,
	Fcoord 		/* y_ll */,
	Fcoord 		/* x_ur */,
	Fcoord 		/* y_ur */
#endif
);
extern	void	Prectangle_fill(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x_ll */,
	Fcoord 		/* y_ll */,
	Fcoord 		/* x_ur */,
	Fcoord 		/* y_ur */
#endif
);
extern	void	Preflection_property(
#if PEXtk_PROTOTYPES
	int 		/* type */,
	Fdata 		/* prop */
#endif
);
extern	int	Preplace_struct(
#if PEXtk_PROTOTYPES
	int 		/* label */
#endif
);
extern	void	Protate(
#if PEXtk_PROTOTYPES
	Angle 		/* a */,
	char 		/* axis */,
	int 		/* flag */
#endif
);
extern	void	Protate_vector(
#if PEXtk_PROTOTYPES
	Fcoord 		/* ox */,
	Fcoord 		/* oy */,
	Fcoord 		/* oz */,
	Fcoord 		/* vx */,
	Fcoord 		/* vy */,
	Fcoord 		/* vz */,
	Angle 		/* a */,
	int 		/* flag */
#endif
);
extern	void	Protate_x(
#if PEXtk_PROTOTYPES
	Angle 		/* a */,
	int 		/* flag */
#endif
);
extern	void	Protate_y(
#if PEXtk_PROTOTYPES
	Angle 		/* a */,
	int 		/* flag */
#endif
);
extern	void	Protate_z(
#if PEXtk_PROTOTYPES
	Angle 		/* a */,
	int 		/* flag */
#endif
);
extern	void	Pscale(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x */,
	Fcoord 		/* y */,
	Fcoord 		/* z */,
	int 		/* flag */
#endif
);
extern	int	Pset_color_equation(
#if PEXtk_PROTOTYPES
	Colormap*	/* cmap       */,
	int* 		/* base_pixel */,
	int 		/* num_red    */,
	int 		/* num_green  */,
	int 		/* num_blue   */,
	int 		/* mult_red   */,
	int 		/* mult_green */,
	int 		/* mult_blue  */,
	Fdata 		/* gamma_val  */
#endif
);
extern	void	Pset_color_mode(
#if PEXtk_PROTOTYPES
	int 		/* mode */
#endif
);
extern	void	Pset_color_table(
#if PEXtk_PROTOTYPES
	int 		/* index */,
	PCOLOR*		/* col */
#endif
);
extern	void	Pset_color_table_hsv(
#if PEXtk_PROTOTYPES
	int 		/* index */,
	Fdata 		/* h */,
	Fdata 		/* s */,
	Fdata 		/* v */
#endif
);
extern	void	Pset_color_table_rgb(
#if PEXtk_PROTOTYPES
	int 		/* index */,
	Fdata 		/* r */,
	Fdata 		/* g */,
	Fdata 		/* b */
#endif
);
extern	void	Pset_display_buffer(
#if PEXtk_PROTOTYPES
	unsigned long 	/* buf */
#endif
);
extern	int	Pset_drawable(
#if PEXtk_PROTOTYPES
	Window   	/* buf */
#endif
);
extern	int	Pset_function(
#if PEXtk_PROTOTYPES
	int   		/* type */,
	int(*)()	/* func */
#endif
);
extern	void	Pset_precision(
#if PEXtk_PROTOTYPES
	int 		/* u_segs */,
	int 		/* v_segs */
#endif
);
extern	void	Pset_update_buffer(
#if PEXtk_PROTOTYPES
	unsigned long 	/* buf */
#endif
);
extern	int	Pset_view_index(
#if PEXtk_PROTOTYPES
	int 		/* id */
#endif
);
extern	void	Pshade_mode(
#if PEXtk_PROTOTYPES
	int 		/* mode */
#endif
);
extern	void	Pshape_flag(
#if PEXtk_PROTOTYPES
	int 		/* flag */
#endif
);
extern	void	Pspecular_color(
#if PEXtk_PROTOTYPES
	PCOLOR*		/* col */
#endif
);
extern	void	Pspecular_color_hsv(
#if PEXtk_PROTOTYPES
	Fdata 		/* h */,
	Fdata 		/* s */,
	Fdata 		/* v */
#endif
);
extern	void	Pspecular_color_ind(
#if PEXtk_PROTOTYPES
	int		/* index */
#endif
);
extern	void	Pspecular_color_rgb(
#if PEXtk_PROTOTYPES
	Fdata 		/* r */,
	Fdata 		/* g */,
	Fdata 		/* b */
#endif
);
extern	void	Psphere(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x   */,
	Fcoord 		/* y   */,
	Fcoord 		/* z   */,
	Fcoord 		/* rad */
#endif
);
extern	void	Psphere_fill(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x   */,
	Fcoord 		/* y   */,
	Fcoord 		/* z   */,
	Fcoord 		/* rad */
#endif
);
extern	int	Pstruct_used(
#if PEXtk_PROTOTYPES
	int 		/* name */
#endif
);
extern	void	Psurface_approx_method(
#if PEXtk_PROTOTYPES
	int 		/* meth */,
	Fdata 		/* u_tol */,
	Fdata 		/* v_tol */
#endif
);
extern	void	Psurface_parm_range(
#if PEXtk_PROTOTYPES
	Fdata 		/* umin */,
	Fdata 		/* umax */,
	Fdata 		/* vmin */,
	Fdata 		/* vmax */
#endif
);
extern	void	Pswap_buffers(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Pswap_tmesh(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	void	Ptext(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x */,
	Fcoord 		/* y */,
	Fcoord 		/* z */,
	char* 		/* string */
#endif
);
extern	void	Ptext_annotate(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x */,
	Fcoord 		/* y */,
	Fcoord 		/* z */,
	char* 		/* string */
#endif
);
extern	void	Ptext_annotate_size(
#if PEXtk_PROTOTYPES
	Fcoord 		/* xsize */,
	Fcoord 		/* ysize */
#endif
);
extern	void	Ptext_color(
#if PEXtk_PROTOTYPES
	PCOLOR*		/* col */
#endif
);
extern	void	Ptext_color_hsv(
#if PEXtk_PROTOTYPES
	Fdata 		/* h */,
	Fdata 		/* s */,
	Fdata 		/* v */
#endif
);
extern	void	Ptext_color_ind(
#if PEXtk_PROTOTYPES
	int 		/* index */
#endif
);
extern	void	Ptext_color_rgb(
#if PEXtk_PROTOTYPES
	Fdata 		/* r */,
	Fdata 		/* g */,
	Fdata 		/* b */
#endif
);
extern	void	Ptext_font(
#if PEXtk_PROTOTYPES
	int 		/* font */
#endif
);
extern	void	Ptext_orientation(
#if PEXtk_PROTOTYPES
	Fcoord 		/* vecx */,
	Fcoord 		/* vecy */
#endif
);
extern	void	Ptext_path(
#if PEXtk_PROTOTYPES
	int 		/* path */
#endif
);
extern	void	Ptext_size(
#if PEXtk_PROTOTYPES
	Fdata 		/* xsize */,
	Fdata 		/* ysize */
#endif
);
extern	void	Ptexture_info(
#if PEXtk_PROTOTYPES
	long 		/* tb */,
	long 		/* tc */,
	int 		/* tn */
#endif
);
extern	void	Ptexture_name(
#if PEXtk_PROTOTYPES
	int 		/* tn */
#endif
);
extern	void	Ptranslate(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x */,
	Fcoord 		/* y */,
	Fcoord 		/* z */,
	int 		/* flag */
#endif
);
extern	void	Ptranslate_x(
#if PEXtk_PROTOTYPES
	Fcoord 		/* x */,
	int 		/* flag */
#endif
);
extern	void	Ptranslate_y(
#if PEXtk_PROTOTYPES
	Fcoord 		/* y */,
	int 		/* flag */
#endif
);
extern	void	Ptranslate_z(
#if PEXtk_PROTOTYPES
	Fcoord 		/* z */,
	int 		/* flag */
#endif
);
extern	void	Ptransparency(
#if PEXtk_PROTOTYPES
	int 		/* mode */,
	Fdata 		/* value */
#endif
);
extern	void	Pvertex(
#if PEXtk_PROTOTYPES
	Fcoord*		/* verts */
#endif
);
extern	void	Pvertex_color(
#if PEXtk_PROTOTYPES
	PCOLOR*		/* col */
#endif
);
extern	void	Pvertex_color_hsv(
#if PEXtk_PROTOTYPES
	Fdata 		/* h */,
	Fdata 		/* s */,
	Fdata 		/* v */
#endif
);
extern	void	Pvertex_color_ind(
#if PEXtk_PROTOTYPES
	int		/* index */
#endif
);
extern	void	Pvertex_color_rgb(
#if PEXtk_PROTOTYPES
	Fdata 		/* r */,
	Fdata 		/* g */,
	Fdata 		/* b */
#endif
);
extern	void	Pvertex_normal(
#if PEXtk_PROTOTYPES
	Fcoord		/* nx */,
	Fcoord		/* ny */,
	Fcoord		/* nz */
#endif
);
extern	void	Pvertex_normals(
#if PEXtk_PROTOTYPES
	int 		/* num   */, 
	Fcoord3D*	/* norms */
#endif
);
extern	void	Pvertex_texture(
#if PEXtk_PROTOTYPES
	Fcoord		/* u */,
	Fcoord		/* v */
#endif
);
extern	void	Pvertex_textures(
#if PEXtk_PROTOTYPES
	int 		/* num   */, 
	Tvar*		/* norms */
#endif
);
extern	void	Pviewport(
#if PEXtk_PROTOTYPES
	Screencoord 	/* left   */, 
	Screencoord 	/* right  */,
	Screencoord 	/* bottom */,
	Screencoord 	/* top    */
#endif
);
extern	void	Pwindow_view(
#if PEXtk_PROTOTYPES
	int 		/* index */, 
	Fcoord 		/* left */,
	Fcoord 		/* right */, 
	Fcoord 		/* bottom */,
	Fcoord 		/* top */,
	Fcoord  	/* near */,
	Fcoord 		/* far */
#endif
);
extern	void	Pzbuffer(
#if PEXtk_PROTOTYPES
	int 		/* mode */
#endif
);
	/*
	 *  Ppixel_value_rgb will return a pixel value
	 *  given an rgb triplet.
	 */
extern	long	Ppixel_value_rgb(
#if PEXtk_PROTOTYPES
	Fdata 		/* r */,
	Fdata 		/* g */,
	Fdata 		/* b */
#endif
);
	/*
	 * Other supported routines
	 */
extern	long	Pindex_color(
#if PEXtk_PROTOTYPES
	int 		/* index */
#endif
);
extern	long	Ppseudo_color(
#if PEXtk_PROTOTYPES
	Fdata 		/* r */,
	Fdata 		/* g */,
	Fdata 		/* b */
#endif
);
extern	long	Ptrue_color(
#if PEXtk_PROTOTYPES
	Fdata 		/* r */,
	Fdata 		/* g */,
	Fdata 		/* b */
#endif
);
extern	long	PEXtk_pseudo_index(
#if PEXtk_PROTOTYPES
	int 		/* index */
#endif
);
extern	long	PEXtk_true_index(
#if PEXtk_PROTOTYPES
	int 		/* index */
#endif
);
extern	int	PEXtk_rgb_index(
#if PEXtk_PROTOTYPES
	PCOLOR 		/* col */
#endif
);
extern	int	PEXtk_rgb_colormap_index(
#if PEXtk_PROTOTYPES
	int 		/* index */,
	float* 		/* r */,
	float* 		/* g */,
	float* 		/* b */
#endif
);
extern	int	PEXtk_matrix_copy(
#if PEXtk_PROTOTYPES
	Matrix  	/* dst */,
	Matrix  	/* src */
#endif
);
extern	int	PEXtk_matrix_mult(
#if PEXtk_PROTOTYPES
	Matrix  	/* l */,
	Matrix  	/* r */,
	Matrix  	/* prod */
#endif
);

extern	unsigned long	Pget_Renderer_ID(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	unsigned long	Pget_View_ID(
#if PEXtk_PROTOTYPES
	void
#endif
);
extern	Window	Pcreate_window(
#if PEXtk_PROTOTYPES
	Display* 	/* disp   */,
	int 		/* width  */,
	int		/* height */
#endif
);
extern	int	PEXtk_calc_vertex_normals(
#if PEXtk_PROTOTYPES
	int 		/* nverts */,
	int 		/* npolys */,
	Fcoord3D*	/* vl     */,
	short* 		/* fC     */,
	short* 		/* edges  */,
	Fcoord3D**	/* vnorm  */
#endif
);
extern	int	PEXtk_convert_hsv_to_rgb(
#if PEXtk_PROTOTYPES
	Fdata 		/* h */,
	Fdata 		/* s */,
	Fdata 		/* v */,
	Fdata* 		/* r */,
	Fdata* 		/* g */,
	Fdata* 		/* b */
#endif
);

#if defined(__cplusplus) || defined (c_plusplus)
	}
#endif /* __cplusplus */

#endif /* PEXTK_H */
