/*
 *  $Header: /auto/nfs/sequoia/u/home/rws/pextk/src/pextk_def.h,v 1.1 1993/10/12 00:07:43 rws Exp $
 ******************************************************************************
 ******************************************************************************
 *****                           pextk_def.h                              *****
 *****									  *****
 *****		    An Immediate Mode Interface to PEX			  *****
 *****									  *****
 *****									  *****
 *****    This module contains definitions used internally to pextk       *****
 *****									  *****
 *                                                                            *
 *	Copyright 1992, All Rights Reserved                                   *
 *			SHOgraphics					      *
 *			1890 North Shoreline Blvd			      *
 *			Mountain View, CA    94043			      *
 *                                                                            *
 *****									  *****

    Permission to use, copy, modify, and distribute this software and
 its documentation for any purpose and without fee is hereby granted,
 provided that the above copyright notice appear in all copies and that
 both that copyright notice and this permission notice appear in
 supporting documentation, and that the names of SHOgraphics,
 the X Consortium, and MIT not be used in advertising or publicity
 pertaining to distribution of the software without specific, written
 prior permission.

 SHOGRAPHICS DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 INCLUDING ALL EXPRESSED AND IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS. IN NO EVENT SHALL SHOGRAPHICS BE LIABLE FOR ANY DAMAGES OF ANY
 KIND, INCLUDING BUT NOT LIMITED TO SPECIAL, INDIRECT OR CONSEQUENTIAL 
 DAMAGES RESULTING FROM LOSS OF USE, DATA OR PROSPECTIVE PROFITS, WHETHER 
 IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS ACTION, ARISING OUT 
 OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

 ************************************************************************ */

/* X Window variables */
	static Display		*dpy;
	static int		win_screen;
	static GC		gc;

	static Colormap		win_colormap;	/* default colormap */
	static Colormap		win_8bit_cmap;	/* 8 bit allocated colormap */
	static int		win_depth;		/* cur screen depth */

/* PEXlib variables */

	/*static pxlOCBuf		*IMBuf;	/* immediate mode OC Buffer */
	/*static pxlOCBuf		*STRBuf;/* retained  mode OC Buffer */
	/*static pxlOCBuf		*OCBuf; /* current/active OC Buffer */

	static PEXListOfVertex Ppolygon;/* struct for PEXMultiFillAreaData */

	static PEXLightEntry	light_table;
	static PEXDepthCueEntry	Depthcue_table;
       	static PEXLookupTable	Light_ID, Light_ID0;
	static PEXTableIndex	LightOnTable[PEXtk_MAX_LIGHTS+1];
	static PEXMatrix local_mtx;
	static PEXFacetData	facetData;


/* PEXtk variables */

	static PEXtk_ATTRIB	p_attrib[PEXtk_ATTRIB_SIZE];
	static PEXName		*name_stk;
	static int		active_light_mask;

	static PEXTK_OBJECT		p_object;
	static PEXTK_STATE		pstate;
	static PEXTK_BUILD		pbuild;
	static PEXTK_SUPPORT		psupport;
	static PEXTK_BUFFER		pbuffer;
	static PEXTK_DLS_OBJECT		p_dl_obj;
	static CTABLE_OBJECT		clr_tbl;
	static PEXTK_X			px_data;

	/* static PEX_OBJECT		*pex_obj; */

	static Matrix ident_mat  =     {{1.0, 0.0, 0.0, 0.0},
                                        {0.0, 1.0, 0.0, 0.0},
                                        {0.0, 0.0, 1.0, 0.0},
                                        {0.0, 0.0, 0.0, 1.0}};



/* PEXtk pointer variables */

	static PEXTK_OBJECT		*p__object;
	static PEXTK_STATE		*p_state;
	static PEXTK_BUILD		*p_build;
	static PEXTK_SUPPORT		*p_support;
	static PEXTK_BUFFER 		*p_buffer;
	static PEXTK_DLS_OBJECT		*p_dl;
	static CTABLE_OBJECT		*p_clr;
	static PEXTK_X			*p_x_data;

#define DB_CHECK_DIRTY_MASK( mask ) \
	if( IMMEDIATE_MODE( pstate.sys_mode )) \
	    DB_check_dirty_mask( mask )
