/*
 *  $Header: /auto/nfs/sequoia/u/home/rws/pextk/src/pextk_ops.h,v 1.1 1993/10/12 00:07:43 rws Exp $
 ******************************************************************************
 ******************************************************************************
 *****                           pextk_ops.h                              *****
 *****									  *****
 *****		    An Immediate Mode Interface to PEX			  *****
 *****									  *****
 *****									  *****
 *****      This module contains the opcode definitions for  pextk        *****
 *****									  *****
 *                                                                            *
 *	Copyright 1992, All Rights Reserved                                   *
 *			SHOgraphics					      *
 *			1890 North Shoreline Blvd			      *
 *			Mountain View, CA    94043			      *
 *                                                                            *
 *****									  *****

    Permission to use, copy, modify, and distribute this software and
 its documentation for any purpose and without fee is hereby granted,
 provided that the above copyright notice appear in all copies and that
 both that copyright notice and this permission notice appear in
 supporting documentation, and that the names of SHOgraphics,
 the X Consortium, and MIT not be used in advertising or publicity
 pertaining to distribution of the software without specific, written
 prior permission.

 SHOGRAPHICS DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 INCLUDING ALL EXPRESSED AND IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS. IN NO EVENT SHALL SHOGRAPHICS BE LIABLE FOR ANY DAMAGES OF ANY
 KIND, INCLUDING BUT NOT LIMITED TO SPECIAL, INDIRECT OR CONSEQUENTIAL 
 DAMAGES RESULTING FROM LOSS OF USE, DATA OR PROSPECTIVE PROFITS, WHETHER 
 IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS ACTION, ARISING OUT 
 OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

 ************************************************************************ */

/*
 * Display List support definitions
 */

#define		PEXtk_FUNC_NO_OP		0x0100
#define		PEXtk_FUNC_XFORM		0x0200
#define		PEXtk_FUNC_PRIM			0x0400
#define		PEXtk_FUNC_ATTRIB		0x0800
#define		PEXtk_FUNC_STATE		0x1000
#define		PEXtk_FUNC_VIEW 		0x2000
#define		PEXtk_FUNC_EXEC 		0x4000
#define		PEXtk_FUNC_EXTEN  		0x8000

#define		PEXtk_FUNC_MASK			0xff00
#define		PEXtk_FUNC_UMASK		0x00ff

#define 	PEXtk_OP_DPY_LIST		(PEXtk_FUNC_NO_OP | 0x0001)
#define 	PEXtk_OP_ARC			(PEXtk_FUNC_PRIM  | 0x0001)
#define 	PEXtk_OP_ARC_FILL		(PEXtk_FUNC_PRIM  | 0x0002)
#define 	PEXtk_OP_BACKFACE		(PEXtk_FUNC_ATTRIB| 0x0001)
#define 	PEXtk_OP_BORDER			(PEXtk_FUNC_ATTRIB| 0x0002)
#define 	PEXtk_OP_BUFFER_MODE		(PEXtk_FUNC_STATE | 0x0001)
#define 	PEXtk_OP_CALL_DLS		(PEXtk_FUNC_EXEC  | 0x0001)
#define 	PEXtk_OP_CALL_STRUCT		(PEXtk_FUNC_EXEC  | 0x0002)
#define 	PEXtk_OP_VIEW_ORTHO		(PEXtk_FUNC_VIEW  | 0x0002)
#define 	PEXtk_OP_VIEW_ORTHO_2D		(PEXtk_FUNC_VIEW  | 0x0003)
#define 	PEXtk_OP_VIEW_PERSP		(PEXtk_FUNC_VIEW  | 0x0004)
#define 	PEXtk_OP_VIEW_WINDOW		(PEXtk_FUNC_VIEW  | 0x0005)
#define 	PEXtk_OP_VIEW_POLAR		(PEXtk_FUNC_VIEW  | 0x0006)
#define 	PEXtk_OP_VIEW_LOOKAT		(PEXtk_FUNC_VIEW  | 0x0007)

#define 	PEXtk_OP_CIRCLE			(PEXtk_FUNC_PRIM  | 0x0003)
#define 	PEXtk_OP_CIRCLE_FILL		(PEXtk_FUNC_PRIM  | 0x0004)
#define 	PEXtk_OP_CLIP_RECT		(PEXtk_FUNC_VIEW  | 0x0008)
#define 	PEXtk_OP_CLEAR			(PEXtk_FUNC_VIEW  | 0x0009)
#define 	PEXtk_OP_CLEAR_IND		(PEXtk_FUNC_VIEW  | 0x000a)
#define 	PEXtk_OP_CLEAR_RGB		(PEXtk_FUNC_VIEW  | 0x000b)
#define 	PEXtk_OP_CLEAR_HSV		(PEXtk_FUNC_VIEW  | 0x000c)
#define 	PEXtk_OP_COLOR			(PEXtk_FUNC_ATTRIB| 0x0003)
#define 	PEXtk_OP_COLOR_IND		(PEXtk_FUNC_ATTRIB| 0x0004)
#define 	PEXtk_OP_COLOR_RGB		(PEXtk_FUNC_ATTRIB| 0x0005)
#define 	PEXtk_OP_COLOR_HSV		(PEXtk_FUNC_ATTRIB| 0x0006)
#define 	PEXtk_OP_COLOR_SPEC		(PEXtk_FUNC_ATTRIB| 0x0007)
#define 	PEXtk_OP_COLOR_SPEC_IND		(PEXtk_FUNC_ATTRIB| 0x0008)
#define 	PEXtk_OP_COLOR_SPEC_RGB		(PEXtk_FUNC_ATTRIB| 0x0009)
#define 	PEXtk_OP_COLOR_SPEC_HSV		(PEXtk_FUNC_ATTRIB| 0x000a)
#define 	PEXtk_OP_DEPTH			(PEXtk_FUNC_VIEW  | 0x000d)
#define 	PEXtk_OP_DEPTH_CUE		(PEXtk_FUNC_VIEW  | 0x000e)
#define 	PEXtk_OP_DITHER			(PEXtk_FUNC_STATE | 0x0002)
#define 	PEXtk_OP_EXEC_STRUCT		(PEXtk_FUNC_EXEC  | 0x0003)

#define 	PEXtk_OP_LIGHT			(PEXtk_FUNC_ATTRIB| 0x000b)
#define 	PEXtk_OP_LIGHT_AMB		(PEXtk_FUNC_ATTRIB| 0x000c)
#define 	PEXtk_OP_LIGHT_CLR		(PEXtk_FUNC_ATTRIB| 0x000d)
#define 	PEXtk_OP_LIGHT_CLR_IND		(PEXtk_FUNC_ATTRIB| 0x000e)
#define 	PEXtk_OP_LIGHT_CLR_RGB		(PEXtk_FUNC_ATTRIB| 0x000f)
#define 	PEXtk_OP_LIGHT_CLR_HSV		(PEXtk_FUNC_ATTRIB| 0x0010)
#define 	PEXtk_OP_LINE_CLR  		(PEXtk_FUNC_ATTRIB| 0x0011)
#define 	PEXtk_OP_LINE_CLR_IND		(PEXtk_FUNC_ATTRIB| 0x0012)
#define 	PEXtk_OP_LINE_CLR_RGB		(PEXtk_FUNC_ATTRIB| 0x0013)
#define 	PEXtk_OP_LINE_CLR_HSV		(PEXtk_FUNC_ATTRIB| 0x0014)
#define 	PEXtk_OP_LINE_TYPE 		(PEXtk_FUNC_ATTRIB| 0x0015)
#define 	PEXtk_OP_LINE_WIDTH 		(PEXtk_FUNC_ATTRIB| 0x0016)
#define 	PEXtk_OP_LD_MTX			(PEXtk_FUNC_STATE | 0x0003)
#define 	PEXtk_OP_LD_IDENT		(PEXtk_FUNC_STATE | 0x0004)
#define 	PEXtk_OP_LOGICAL		(PEXtk_FUNC_EXTEN | 0x0001)

#define 	PEXtk_OP_MAKE_LABEL		(PEXtk_FUNC_ATTRIB| 0x0017)
#define 	PEXtk_OP_MRKR			(PEXtk_FUNC_PRIM  | 0x0005)
#define 	PEXtk_OP_MRKR_CLR		(PEXtk_FUNC_ATTRIB| 0x0018)
#define 	PEXtk_OP_MRKR_CLR_IND		(PEXtk_FUNC_ATTRIB| 0x0019)
#define 	PEXtk_OP_MRKR_CLR_RGB		(PEXtk_FUNC_ATTRIB| 0x001a)
#define 	PEXtk_OP_MRKR_CLR_HSV		(PEXtk_FUNC_ATTRIB| 0x001b)
#define 	PEXtk_OP_MRKR_SCALE		(PEXtk_FUNC_ATTRIB| 0x001c)
#define 	PEXtk_OP_MRKR_TYPE		(PEXtk_FUNC_ATTRIB| 0x001d)

#define 	PEXtk_OP_MATRIX_MODE		(PEXtk_FUNC_STATE | 0x0005)

#define 	PEXtk_OP_PICK_ID		(PEXtk_FUNC_ATTRIB| 0x001e)
#define 	PEXtk_OP_PLANE_MASK		(PEXtk_FUNC_EXTEN | 0x0002)
#define 	PEXtk_OP_POLY			(PEXtk_FUNC_PRIM  | 0x0006)
#define 	PEXtk_OP_POLY_FILL		(PEXtk_FUNC_PRIM  | 0x0007)
#define 	PEXtk_OP_POLY_LINE		(PEXtk_FUNC_PRIM  | 0x0008)
#define 	PEXtk_OP_POLY_INDEX		(PEXtk_FUNC_PRIM  | 0x0009)
#define 	PEXtk_OP_POLY_NORMAL		(PEXtk_FUNC_ATTRIB| 0x001f)
#define 	PEXtk_OP_POLY_SHADE		(PEXtk_FUNC_PRIM  | 0x000a)
#define 	PEXtk_OP_POLY_SHADE_TEX		(PEXtk_FUNC_PRIM  | 0x000b)
#define 	PEXtk_OP_POLY_TEX		(PEXtk_FUNC_PRIM  | 0x000c)
#define 	PEXtk_OP_POLY_W_DATA		(PEXtk_FUNC_PRIM  | 0x000d)

#define 	PEXtk_OP_PUSH_ATTR		(PEXtk_FUNC_STATE | 0x0006)
#define 	PEXtk_OP_POP_ATTR		(PEXtk_FUNC_STATE | 0x0007)
#define 	PEXtk_OP_PUSH_VIEW		(PEXtk_FUNC_STATE | 0x0008)
#define 	PEXtk_OP_POP_VIEW		(PEXtk_FUNC_STATE | 0x0009)
#define 	PEXtk_OP_PUSH_MTX		(PEXtk_FUNC_STATE | 0x000a)
#define 	PEXtk_OP_POP_MTX		(PEXtk_FUNC_STATE | 0x000b)
#define 	PEXtk_OP_PUSH_VPT		(PEXtk_FUNC_STATE | 0x000c)
#define 	PEXtk_OP_POP_VPT		(PEXtk_FUNC_STATE | 0x000d)
#define 	PEXtk_OP_PUSH_NAME		(PEXtk_FUNC_STATE | 0x000e)
#define 	PEXtk_OP_POP_NAME		(PEXtk_FUNC_STATE | 0x000f)

#define 	PEXtk_OP_PNT_2D    		(PEXtk_FUNC_PRIM  | 0x000e)
#define 	PEXtk_OP_PNT_3D    		(PEXtk_FUNC_PRIM  | 0x000f)
#define 	PEXtk_OP_PNT_NV 		(PEXtk_FUNC_PRIM  | 0x0010)
#define 	PEXtk_OP_PNT_UV 		(PEXtk_FUNC_PRIM  | 0x0011)
#define 	PEXtk_OP_PNT_UVNV 		(PEXtk_FUNC_PRIM  | 0x0012)

#define 	PEXtk_OP_RECT			(PEXtk_FUNC_PRIM  | 0x0013)
#define 	PEXtk_OP_RECT_FILL		(PEXtk_FUNC_PRIM  | 0x0014)
#define 	PEXtk_OP_REFL_PROP		(PEXtk_FUNC_ATTRIB| 0x0020)
#define 	PEXtk_OP_ROT			(PEXtk_FUNC_XFORM | 0x0001)
#define 	PEXtk_OP_ROT_V0			(PEXtk_FUNC_XFORM | 0x0002)
#define 	PEXtk_OP_ROT_V1			(PEXtk_FUNC_XFORM | 0x0003)
#define 	PEXtk_OP_ROT_X			(PEXtk_FUNC_XFORM | 0x0004)
#define 	PEXtk_OP_ROT_Y			(PEXtk_FUNC_XFORM | 0x0005)
#define 	PEXtk_OP_ROT_Z			(PEXtk_FUNC_XFORM | 0x0006)
#define 	PEXtk_OP_SCALE			(PEXtk_FUNC_XFORM | 0x0007)
#define 	PEXtk_OP_SET_DRAWABLE		(PEXtk_FUNC_STATE | 0x0010)
#define 	PEXtk_OP_SET_VIEW		(PEXtk_FUNC_VIEW  | 0x000f)
#define 	PEXtk_OP_SHADE_MODE		(PEXtk_FUNC_STATE | 0x0011)
#define 	PEXtk_OP_TEXT    		(PEXtk_FUNC_PRIM  | 0x0015)
#define 	PEXtk_OP_TEXT_CLR		(PEXtk_FUNC_ATTRIB| 0x0021)
#define 	PEXtk_OP_TEXT_CLR_IND		(PEXtk_FUNC_ATTRIB| 0x0022)
#define 	PEXtk_OP_TEXT_CLR_RGB		(PEXtk_FUNC_ATTRIB| 0x0023)
#define 	PEXtk_OP_TEXT_CLR_HSV		(PEXtk_FUNC_ATTRIB| 0x0024)
#define 	PEXtk_OP_TEXT_ANNO    		(PEXtk_FUNC_PRIM  | 0x0016)
#define 	PEXtk_OP_TEXT_FNT		(PEXtk_FUNC_ATTRIB| 0x0025)
#define 	PEXtk_OP_TEXT_OR		(PEXtk_FUNC_ATTRIB| 0x0026)
#define 	PEXtk_OP_TEXT_PATH		(PEXtk_FUNC_ATTRIB| 0x0027)
#define 	PEXtk_OP_TEXT_SZ		(PEXtk_FUNC_ATTRIB| 0x0028)
#define 	PEXtk_OP_TEXTA_SZ		(PEXtk_FUNC_ATTRIB| 0x0029)
#define 	PEXtk_OP_TRAN			(PEXtk_FUNC_XFORM | 0x0008)
#define 	PEXtk_OP_TRAN_X			(PEXtk_FUNC_XFORM | 0x0009)
#define 	PEXtk_OP_TRAN_Y			(PEXtk_FUNC_XFORM | 0x000a)
#define 	PEXtk_OP_TRAN_Z			(PEXtk_FUNC_XFORM | 0x000b)
#define 	PEXtk_OP_TRANSPARENCY		(PEXtk_FUNC_ATTRIB| 0x002a)
#define 	PEXtk_OP_VPT			(PEXtk_FUNC_VIEW  | 0x0011)
#define 	PEXtk_OP_VERTEX			(PEXtk_FUNC_PRIM  | 0x0017)
#define 	PEXtk_OP_VERTEX_CLR		(PEXtk_FUNC_ATTRIB| 0x002b)
#define 	PEXtk_OP_VERTEX_NORM		(PEXtk_FUNC_ATTRIB| 0x002c)
#define 	PEXtk_OP_Z_BUFFER		(PEXtk_FUNC_STATE | 0x0012)

